IT: OTS (China) -0000 #454

v4.0: Product - Step 1
02/11/2025 10:44 AM - Junyi Zhang

Status:
Priority:
Assignee:
Category:

Target version:

oo

a0
Junyi Zhang

v4.0

Start date:
Due date:

% Done:

Spent time:

Estimated time:

02/14/2025
03/31/2025
100%
100.00 hours
0.00 hour

Description
Background

1. New requirement for v4.0 OTS

See: OneDrive\l00000000000\Shanghai Group - IMIO0MoTS vall00

Task Details
« 1.sBx0000000000000Database TabledOM

. Product000000000000Ts<->s8x00000000000000000+0000
. Category 00000000

. Manufacturer [000000000000000000000

.Option 0000000, 00000TS->SBXHoptionl000N0

-tax 00000000

.geo_zone ?

o0 WD =

2.01s[00000000000000000000Database Tablell

Module

Function

Database

Other

Product

12/20/2025

1.s8x00000
2.0TS->SBX00
0oo

3.0000:00 + HS
codell[]
manufacture +

00 + 0000

product
product_descrip
tion
product_to_cate
gory
product_group
product_group_
description
product_option
product_option_
description
product_option_
value
product_option_
value_descriptio
n
product_extra_o
ption
product_extra_o
ption_value
product_discou
nt
product_option_
value_discount
product_image
product_image__
description
product_option_
value_hover_de
scription
product_option_
value_layer_ima
ge
product_square

option&pricelll
SBX
product->manuf

acturer 100000

1/6




_meter_discoun
t
product_to_man
ufacturer(new)
product_to_man
ufacturer_descri
ption(new)

Category

category
category_descri
ption
catageory_path

0oao

Manufacture

name, country,
zone, city
address 1,
address 2

manufacture

0oao

Option

1.s8x00000
2.07S->SBXx00
ooo

option
option_descripti
on

option_value
option_value_d
escription
branding_group
branding_group
_description

0000000sBx0

tax

tax_class
tax_rate
tax_rate_to_cus
tomer_group
tax_rule

gooo

currency

currency
currency_round

gooo

length classes

length_class
length_class_de
scription

0oao

weight classes

weight_class
weight_class_d
escription

aoao

unit classes

unit_class
unit_class_desc
ription

0000000sex0

geo_zone

geo_zone
zone_to_geo_z
one

gooo

country

country

0oao

o 3. OTS[00Import product modulel000000sBXx0000000sqLONO
Bruce:#462

o 4. OTSl0Restful API (Serverl)10000sBXO000000000Dnttps://docs.opencart.com/en-gb/system/users/api/ll

« 5. SBX[Restful API (Client)I00oTsO0000000000000Admin order edit form00000000
Note: U00000000rder10000000rderlOrder ProductllAdd / Edit / Removellll

Questions:

1. 00000sBx000Restful API (Client])0000000000Authl00000000000SBX0admin userlOTSHuserlll
van: [00000emailloTs4.0 O00000emaidd000o0o0o0000000020000user000

2. l0oTslsex00ooo:
- Product
- Option
https://redmine.easydingzhi.com/issues/462

- Option value

van: [0000eT000ia000000000ption value idd0oTS4.000000ProductlOptionlOption valuelial0000000000000000

3. Color option0000000Text Optionl00000option valuelOUNOColor OptionI0000000000000000

vani [[0text type, O000color typeloptionlllcolor optiondO000000000000000000color optiond0O00000O0

v4 coding standard:

1. GitlD

Eﬁ)ﬁxx(redmine number): xxx(redmine title) - xxx(0000000)
2.0000

2.1: [00Public -> Protected -> Private

ﬁnzz goooooosex
3. 000000Mmodelll

3.1: 0000000000 modelllsystem[[

:D3.2: v3/vallmodelll000000000 order.php, order_v3.php
4.1000

tDwig, is, css (js, cssU000000essO0M)

5.0000
lEl/IVCL (LOenlcn)

6. 00
1.000

/**
* XXX
*

* @copyright RedBlue-O0TS 2024

* @version vi4
*

*/

2.00000000 + DOOCD

/**
* XXX
*

* @param XXX S$XXX
* @param xxx S$XXX
* @return xxx
4

Output

® Report and Solution

Others

Related issues:
Copied to 0000 #462: v4.0: Product - Import option & product data from SBX
Copied to 000 #463: v4.0: Product - Step 2

ooo
ooo

02/28/2025
06/02/2025

03/03/2025
10/31/2025

History

#1 - 02/11/2025 07:30 PM - Junyi Zhang

- Description updated

- Status changed from 10 to0010

- Start date changed from 02/17/2025 to 02/12/2025

#2 - 02/13/2025 04:03 PM - Xihua Fan
- Tracker changed from 010 to0000

#3 - 02/13/2025 07:02 PM - Xihua Fan
- Description updated
- Start date changed from 02/12/2025 to 02/14/2025

#4 - 02/14/2025 11:18 AM - Xihua Fan

- Description updated

#5 - 02/14/2025 11:19 AM - Xihua Fan

- Description updated

#6 - 02/14/2025 01:53 PM - Xihua Fan

- Description updated

#7 - 02/14/2025 01:55 PM - Xihua Fan

- Description updated

#8 - 02/14/2025 02:01 PM - Xihua Fan

- Description updated

#9 - 02/14/2025 04:33 PM - Junyi Zhang

- Description updated

#10 - 02/14/2025 04:36 PM - Xihua Fan

- Description updated

#11 - 02/14/2025 05:49 PM - Junyi Zhang

- Description updated

#12 - 02/17/2025 07:08 PM - Junyi Zhang
- File ots_product.xIsx added

Output(2025/02/23 - 2025/3/07)0 (2025/02/17 - 2025/02/21)

1. Functions:

1. Admin: Prepare auxiliary modules around the product module in advance
- Unit class
- Length class
- Weight class
- Tax
- Currency
- Country
- Zone
- Geo zone

2. Admin: Modify the manufacturer and category module.

3. Admin: Add option module.
- Special options: color, size, branding, design method. Important: These special options need to be created first, then set to special in the
setting.
- Limit the option types: select, checkbox, radio, text
- Redundant fields: Some unused fields still be added, because it will make the date transfer from ET4.0 more convenient.

4. Admin setting:
- Add fields for special options: eenfig—coler—option, config—extra—celer—optien , config_size_option, config_design_method_option,
config_branding_option
- Remove config_color_option, config_extra_color_option: About color option, we still use SBX's color options instead of using
'text’ option to represent all color options in front because the color option might have their own price, and we can not use one
single option to cover all situation.

5. Prduct module
- According to SBX product module, design OTS's product module
- Remain tab: General, Data, Link, Price&Option, Image
- Modify Price&Option tab to multiple manufacturers mode, which means each manufacturer has their own prices and options.
- Brand(Declaration):Use {brand}, {dimension} and {capacity} as replacement. And we need add tool/smarty in front.

2. Optimizations:
1. Admin: easyDingZhi.common
- Create easyDingZhi namespace in view/javascript/easydingzhi/common.js
- The common.js should gradually replace OC's own common.js.

2. Common: Ensuring data integrity:

- Add 'transaction' in pdo.php for database rollback when one of the database operations is wrong in a set of database operations.

- 'end_of_data': Add 'end_of_data' in every admin form as a flag. The database operation can succeed if 'end_of_data' exists.

3. Common: IsBXx000admin style
Database:
1.00 #440
TODO:N0000 #463

1. Functions :

1. 0TS v4 Olrestful API, 000000eT v4000000

2. ET v4 O0vestful API, 000000000

#13 - 02/19/2025 10:57 AM - Junyi Zhang
- Description updated

#14 - 02/19/2025 11:02 AM - Junyi Zhang
- Description updated

#15 - 02/19/2025 04:32 PM - Junyi Zhang
- Description updated

#16 - 02/21/2025 11:25 AM - Junyi Zhang
- Description updated

#17 - 02/24/2025 10:18 AM - Junyi Zhang

- Description updated

#18 - 02/24/2025 10:18 AM - Junyi Zhang
- % Done changed from 0 to 30

#19 - 02/24/2025 10:25 AM - Junyi Zhang

- Description updated

#20 - 02/24/2025 02:24 PM - Xihua Fan

- Description updated

#21 - 02/28/2025 05:24 PM - Xihua Fan

- Copied to0 000 #462: v4.0: Product - Import option & product data from SBX added

#22 - 03/03/2025 10:23 AM - Junyi Zhang
- % Done changed from 30 to 60

#23 - 03/03/2025 10:30 AM - Junyi Zhang

- Description updated

#24 - 03/03/2025 10:33 AM - Junyi Zhang
- File deleted (ots_product.xlsx)

#25 - 03/06/2025 05:21 PM - Junyi Zhang

- Copied to0 000 #463: v4.0: Product - Step 2 added

#26 - 03/06/2025 05:27 PM - Junyi Zhang

- Subject changed from v4.0: Product to v4.0: Product - 1

- Description updated

- Status changed from 100 to0010
https://redmine.easydingzhi.com/issues/440
https://redmine.easydingzhi.com/issues/463

- % Done changed from 60 to 100

#27 - 11/28/2025 02:41 PM - Xihua Fan
- Subject changed from v4.0: Product - 1 to v4.0: Product - Step 1
